package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;

/**
 * bvꂽϐIuWFNgłB<br/>
 * <br/>
 * 쐬: 2005/02/05
 * 
 * @author m.matsubara
 */
public class WrappedVariableExpression implements IParsedExpression {
    private String variableName;    //  gȂHifobO@\gj
    private Integer variableId;
    
    private int offset = 0;    //  ϐւ̃CfbNXiRuntimeDataŕϐւ̃ANZXɎgijj
    
    public WrappedVariableExpression(String variableName, Integer variableId) {
        this.variableName = variableName;
        this.variableId = variableId;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        if (variableId.intValue() == id.intValue()) {
            return 1;
        } else {
            return 0;
        }
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public Object evaluate(RuntimeData runtime) throws ExpException {
        if (offset != 0) {
            if (offset > 0)
                return runtime.getVariable(variableId, offset);
            else
                return runtime.getVariable(variableId, false);  //  offsetȂŕϐ擾B
        }
        else {
            offset = runtime.getVariableOffset(variableId);
            if (offset != 0)
                return runtime.getVariable(variableId, offset);
            else {
                offset = -1;
            	return runtime.getVariable(variableId, true);  //  offsetȂŕϐ擾BϐȂꍇ͍쐬
            }
        }
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isConst()
     */
    public boolean isConst() {
        return false;
    }
    
    /**
     * ϐ̎擾
     * @return ϐ
     */
    public String getVariableName() {
        return variableName;
    }
}
