package jp.gr.java_conf.matsubara.expresser.type.constructor;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpObject;

/**
 * Object^̃RXgN^łB<br/>
 * <br/>
 * 쐬: 2005/05/01
 * 
 * @author m.matsubara
 */

public class ExpObject_constructor extends ExpFunctionBase {
    public static final Integer propertyId$prototype = StringToId.toId("prototype");

    /**
     * Object^̃RXgN^𐶐܂B 
     * @throws ExpException
     */
    public ExpObject_constructor() throws ExpException {
        super("Object", 1);
        putProperty(StringToId.toId("prototype"), ExpObject.getPrototype());
    }


    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public Object callFunction(RuntimeData runtime, Object thisObject, Object[] arguments)
            throws ExpException {
        return new ExpObject();
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public Object getProperty(Integer id) throws ExpException {
        if (id.intValue() == ExpObject_constructor.propertyId$prototype.intValue())
            return ExpObject.getPrototype();
        return super.getProperty(id);
    }
    
}
