package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;
import jp.gr.java_conf.matsubara.expresser.type._Long;

/**
 * Number^ intValue() \bhłB<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */
public class Number__longValue extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("longValue");
    private static IFunction instance = null;  

    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Number__longValue() throws ExpException {
        super("longValue", 0);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public Object callFunction(RuntimeData runtime, Object thisObject, Object[] arguments)
            throws ExpException {
        ExpNumberBase number = (ExpNumberBase)thisObject; 
        return new _Long(number.longValue());
    }

    /**
     * B̃CX^XԂ܂B
     * @return IFunction ^̃CX^X
     */
    public static IFunction getInstance() throws ExpException {
        if (instance == null)
            instance = new Number__longValue();
        return instance;
    }
}
