package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;
import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * String^ concat() \bhłB<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */

public class String__concat extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("concat");
    private static IFunction instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private String__concat() throws ExpException {
        super("concat", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public Object callFunction(RuntimeData runtime, Object thisObject, Object[] arguments)
            throws ExpException {
        String value = ((IExpObject)thisObject).toString();
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);

        //  Z
        String catStr = arguments[0].toString();
        value = value.concat(catStr);
        return new _String(value);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IFunction ^̃CX^X
     */
    public static IFunction getInstance() throws ExpException {
        if (instance == null)
            instance = new String__concat();
        return instance;
    }
}
