package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;
import jp.gr.java_conf.matsubara.expresser.type._Character;

/**
 * String^ toChar() \bhłB<br/>
 * ̃\bh ECMA262 ̃\bhł͂܂B<br/>
 * <br/>
 * 쐬: 2005/04/03
 * 
 * @author m.matsubara
 */

public class String__toChar extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("toChar");
    private static IFunction instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private String__toChar() throws ExpException {
        super("toChar", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public Object callFunction(RuntimeData runtime, Object thisObject, Object[] arguments)
            throws ExpException {
        String value = ((IExpObject)thisObject).toString();
        _Character ch = new _Character(value);
        return ch;
    }

    /**
     * B̃CX^XԂ܂B
     * @return IFunction ^̃CX^X
     */
    public static IFunction getInstance() throws ExpException {
        if (instance == null)
            instance = new String__toChar();
        return instance;
    }
}
