package jp.gr.java_conf.matsubara.regexp;


/**
 * K\RANX𐶐t@NgłB<br/>
 * <br/>
 * 쐬: 2005/08/06
 * 
 * @author m.matsubara
 */
public class RegExpCoreFactory {
    public static IRegExpCore create() throws Exception {
        IRegExpCore regExpCore = null;
        String[] classNames = { 
                "jp.gr.java_conf.matsubara.regexp.ORORegExpCore", 
                "jp.gr.java_conf.matsubara.regexp.JavaRegExpCore",
        };
        Class regExpCoreClass = null;
        int max = classNames.length;
        for (int idx = 0; idx < max; idx++) {
            regExpCoreClass = Class.forName("jp.gr.java_conf.matsubara.regexp.JavaRegExpCore");
            if (regExpCoreClass != null)
                break;
        }
        if (regExpCoreClass == null) {
            throw new Exception("RegExp class create failure.");
        }
        regExpCore = (IRegExpCore)(regExpCoreClass.newInstance());
        return regExpCore; 
    }
}
