package jp.gr.java_conf.matsubara.expresser;

import jp.gr.java_conf.matsubara.expresser.exception.ExpException;

/**
 * ϐNXłB<br/>
 * <br/>
 * @author m.matsubara
 */
public class Variable implements IVariable {
    public static final Object UNINITIALIZED = new Object();
    
    //private Class clsType;
    private Object oValue;
    private boolean bConst;
    
    
    
    public Variable() {
        this.oValue = UNINITIALIZED;
        //this.clsType = Object.class;
        this.bConst = false;
    }
    
    public Variable(Object oValue) {
        this.oValue = oValue;
/*
        if (oValue != null)
            this.clsType = oValue.getClass();
        else
            this.clsType = Object.class;
*/            
        this.bConst = false;
    }

    public Variable(Object oValue, boolean bConst) {
        this.oValue = oValue;
/*        
        if (oValue != null)
            this.clsType = oValue.getClass();
        else
            this.clsType = Object.class;
*/            
        this.bConst = bConst;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#getClsType()
     */
/*    
    public Class getClsType() {
        return clsType;
    }
*/    
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#setClsType(java.lang.Class)
     */
/*
    public void setClsType(Class clsType) {
        this.clsType = clsType;
    }
*/    
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#getValue()
     */
    public Object getValue() throws ExpException {
        if (oValue == UNINITIALIZED)
            throw new ExpException(Expresser.getResString("UndefinedVariable"), -1);
        return oValue;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#setValue(java.lang.Object)
     */
    public void setValue(Object oValue) throws ExpException {
        if (bConst) 
            throw new ExpException(Expresser.getResString("NotSubstituteToConstant"), -1);
        this.oValue = oValue;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#isConst()
     */
    public boolean isConst() throws ExpException {
        return bConst;
    }
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IVariable#setConst(boolean)
     */
    public void setConst(boolean bConst) throws ExpException {
        this.bConst = bConst;
    }
}
