package jp.gr.java_conf.matsubara.expresser.parsedexpression;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpNumberBase;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;
import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * bvꂽ萔lłB<br/>
 * lƂ IVariable n邱Ƃ͑OƂĂ܂B <br/>
 * <br/>
 * 쐬: 2005/02/05
 * 
 * @author m.matsubara
 */
public class WrappedExpression implements IParsedExpression {
    private Object value;
    
    public WrappedExpression(Object value) {
        this.value = value;
    }

    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isUsingVariable(Integer)
     */
    public int isUsingVariable(Integer id) throws ExpException {
        //  Ȃ
        return 0;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#evaluate(jp.gr.java_conf.matsubara.expresser.RuntimeData)
     */
    public Object evaluate(RuntimeData runtime) {
        return value;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.IParsedExpression#isConst()
     */
    public boolean isConst() {
        //  v~eBu^̒萔^̂ true Ƃ
        if (value instanceof ExpNumberBase)
            return true;
        else if (value instanceof _Boolean)
            return true;
        else if (value instanceof _String)
            return true;
        else
            return false;
    }
}
