package jp.gr.java_conf.matsubara.expresser.type;

import java.lang.reflect.*;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.exception.*;


/**
 * JavazXgIuWFNg̃NX\܂B<br/>
 * <br/>
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 */
public class JavaClass implements IFunction {
    private Class javaClass;
    
    public JavaClass(Class javaClass) {
        this.javaClass = javaClass;
    }
    
    public Field getField(String fieldName) throws NoSuchFieldException {
        return javaClass.getField(fieldName);
    }
    
    public Class getJavaClass() {
        return javaClass;
    }
    
    /**
     * VCX^X𐶐܂
     * 
     * @return ꂽCX^X
     * @throws InstantiationException
     * @throws IllegalAccessException
     */
    public Object newInstance()  throws InstantiationException, IllegalAccessException {
        return javaClass.newInstance();
    }

    /**
     * VCX^X𐶐܂
     * @param params RXgN^̃p[^
     * @return ꂽCX^X
     * @throws NoSuchMethodException
     * @throws InstantiationException
     * @throws InvocationTargetException
     * @throws IllegalAccessException
     */
    public Object newInstance(Object[] params)  throws NoSuchMethodException, InstantiationException, InvocationTargetException, IllegalAccessException {
        Class[] paramTypes = JavaObjectMember.createParamTypes(params);
            
        Constructor constructor = javaClass.getConstructor(paramTypes);
        return constructor.newInstance(params);
    }
    
    /*
     * IFunction̎<br/>
     * NX֐ƂČĂяoꍇ̓RXgN^Ăяo
     * 
     */
    public Object callFunction(RuntimeData runtime, Object thisObject, Object[] params) throws ExpException {
        try {
            return newInstance(params);
        } catch (Exception e) {
            throw new ExpException(Expresser.getResString("FailureCreateObject") + " : " + javaClass.getName(), 0);
        }
    }
    
    public String toString() {
        return javaClass.toString();
    }
}
