package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;

/**
 * Array^ push() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class Array__push extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("push");
    private static IFunction instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__push() throws ExpException {
        super("push", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public Object callFunction(RuntimeData runtime, Object thisObject, Object[] arguments)
            throws ExpException {
        IArray value = (IArray)thisObject;
        
        int length = value.length();
        int max = arguments.length;
        for (int idx = 0; idx < max; idx++) {
            value.putProperty(length + idx, arguments[idx]);
        }
        return value;
    }

    /**
     * B̃CX^XԂ܂B
     * @return IFunction ^̃CX^X
     */
    public static IFunction getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__push();
        return instance;
    }
}
