package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.ExpRegExp;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type.IFunction;
import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * String^ match() \bhłB<br/>
 * <br/>
 * 쐬: 2005/07/24
 * 
 * @author m.matsubara
 */

public class String__match extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("match");
    private static IFunction instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private String__match() throws ExpException {
        super("match", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public Object callFunction(RuntimeData runtime, Object thisObject, Object[] arguments)
            throws ExpException {
        String value = ((IExpObject)thisObject).toString();
        if (arguments.length < 1)
            throw new ExpException(Expresser.getResString("ArgumentsNumberError"), -1);

        //  TODO ExpRegExp  global vpeBǉ炻̏Lq邱
        ExpRegExp regExp = null;
        if (arguments[0] instanceof ExpRegExp) {
            regExp = (ExpRegExp)(arguments[0]);
        } else if (arguments[0] instanceof _String) {
            regExp = new ExpRegExp(((_String)arguments[0]).toString(), "");
        } else {
            throw new ExpException(Expresser.getResString("ArgumentError"), -1);
        }
        return regExp.exec(value);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IFunction ^̃CX^X
     */
    public static IFunction getInstance() throws ExpException {
        if (instance == null)
            instance = new String__match();
        return instance;
    }
}
